-- TODO: custom buff coloring, sort order?

add_interceptor("/charpane.php", function()
	if character["use custom kolproxy charpane"] ~= "yes" then return end
	if not pcall(turnsthisrun) then return end -- in afterlife
-- name
-- level / progress
-- mus / mys / mox
-- full / drunk / spleen
-- hp / maxhp
-- mp / maxmp
-- meat
-- advs / turnsplayed
-- mcd ??
-- zone
-- semirare
-- familiar, weight, bonus
-- buffs
	local function pathdesc()
		local prefix = ""
		if ascensionstatus() == "Hardcore" then
			prefix = "HC"
		elseif ascensionstatus() == "Softcore" then
			prefix = "SC"
		end
		if moonsign() == "Bad Moon" then
			return "BM"
		elseif ascensionpath() == "Teetotaler" then
			return prefix .. "T"
		elseif ascensionpath() == "Boozetefarian" then
			return prefix .. "B"
		elseif ascensionpath() == "Oxygenarian" then
			return prefix .. "O"
		elseif ascensionpath() == nil or ascensionpath() == "" or ascensionpath() == "None" then
			-- TODO: add the stupid CDM "5" and "6" path stuff
			if prefix ~= "" then
				return prefix .. "NP"
			else
				return ""
			end
		else
			return prefix .. ":" .. tostring(ascensionpath())
		end
	end

	local function classdesc()
		return ({ "SC", "TT", "PM", "S", "DB", "AT" })[classid()]
	end
	local function classpathdesc()
		local p = pathdesc()
		if p ~= "" then
			return string.format("%s %s", p, classdesc())
		else
			return classdesc()
		end
	end

	local function format_integer(i)
		if i >= 1000 then
			local upper = math.floor(i / 1000)
			return format_integer(upper) .. "," .. string.format("%03d", i - upper * 1000)
		else
			return i
		end
	end

	local function format_hpmp(c, m)
		if c == m then
			return string.format([[<span style="color: green">%s</span>]], format_integer(c))
		elseif c < m * 0.25 then
			return string.format([[<span style="color: red">%s / %s</span>]], format_integer(c), format_integer(m))
		else
			return string.format([[%s / %s]], format_integer(c), format_integer(m))
		end
	end

	local function get_srdata()
		local SRnow, good_numbers, all_numbers, SRmin, SRmax, is_first_semi, lastsemi = get_semirare_info(turnsthisrun())
		local value = ""
		local color = "black"
		if SRnow then
			color = "green"
		end
		if table.maxn(good_numbers) > 0 then
			value = good_numbers[1]
			for x, _ in pairs(good_numbers) do
				if x > 1 then
					value = value .. "+"
				end
			end
		else
			value = "?"
		end

		if (not lastsemi) and (not is_first_semi) then
			lastsemi = "?"
		end
		
		local tooltip = ""
		if table.maxn(all_numbers) > 0 then
			tooltip = tooltip .. "Fortune cookie numbers: " .. table.concat(all_numbers, ", ")
		else
			tooltip = tooltip .. "Fortune cookie numbers: ?"
		end

		if SRmin and SRmax and SRmax >= 0 then
			if value == "?" then
				value = SRmin .. " to " .. SRmax
			end
			tooltip = tooltip .. ", range = " .. SRmin .. " to " .. SRmax
		else
			if value ~= "?" then
				value = value .. "?"
			end
			tooltip = tooltip .. ", range = ?"
		end

		if lastsemi then
			tooltip = tooltip .. ", last semirare = " .. lastsemi
		end
		local bgcolor = "white"
		local showlast = nil
		if SRnow then
			bgcolor = "lightgreen"
		end

		local srdata = string.format([[SR: <span style="color: ]]..color..[[" title="]]..tooltip..[["><b>%s</b></span>]], value)
		if SRnow and lastsemi then
			srdata = srdata .. string.format([[<br>Last SR: %s]], lastsemi)
		end

		return bgcolor, srdata
	end

	local bgcolor, srdata = get_srdata()

	local lines = {}
	table.insert(lines, string.format([[<a class="nounder" target="mainpane" href="charsheet.php"><b>%s</b></a> <span class="tiny">(%s)</span>]], playername(), classpathdesc()))
	table.insert(lines, string.format([[Level: <b>%s</b> <span class="tiny">(%s to go)</span>]], round_down(level() + level_progress(), 1), format_integer(substats_for_level(level() + 1) - rawmainstat())))
-- 	table.insert(lines, string.format([[Mainstat: <b><span style="color: blue; font-weight: bold;">%s</span> (%s)</b>]], format_integer(buffedmainstat()), format_integer(basemainstat())))
	table.insert(lines, string.format([[Buffed: <b><span style="color: blue; font-weight: bold;">%s</span></b> / <b><span style="color: blue; font-weight: bold;">%s</span></b> / <b><span style="color: blue; font-weight: bold;">%s</span></b>]], format_integer(buffedmuscle()), format_integer(buffedmysticality()), format_integer(buffedmoxie())))
	table.insert(lines, string.format([[Base: <b>%s</b> / <b>%s</b> / <b>%s</b>]], format_integer(basemuscle()), format_integer(basemysticality()), format_integer(basemoxie())))
	table.insert(lines, string.format([[Organs: <b>%s</b> / <b>%s</b> / <b>%s</b>]], fullness(), drunkenness(), spleen()))
	table.insert(lines, "")
	table.insert(lines, string.format([[HP: <b>%s</b>]], format_hpmp(hp(), maxhp())))
	table.insert(lines, string.format([[MP: <b>%s</b>]], format_hpmp(mp(), maxmp())))
	table.insert(lines, string.format([[Meat: <b>%s</b>]], format_integer(meat())))
	table.insert(lines, string.format([[Turns: <b>%s</b> <span class="tiny">(%s played)</span>]], advs(), turnsthisrun()))
	table.insert(lines, string.format([[<a href="%s" target="mainpane">Zone</a>: <b><a href="%s" target="mainpane">%s</a></b>]], lastadventuredata().container or "", lastadventuredata().link, lastadventuredata().name))
	table.insert(lines, "<!-- kolproxy charpane text area -->")

	table.insert(lines, srdata)

	local next_bee_turn = ascension["bee turn"]
	local bee_value = nil
	if next_bee_turn then
		local turnmin = next_bee_turn - turnsthisrun()
		local turnmax = next_bee_turn + 5 - turnsthisrun()
		if turnmax >= 0 then
			if turnmin < 0 then turnmin = 0 end
			bee_value = turnmin .. "-" .. turnmax
		end
	else
-- 		bee_value = "?"
	end
	if bee_value then
		table.insert(lines, string.format([[Bee: %s]], bee_value))
	end

	do
		local tbl = get_ascension_state("turn counters")
		if tbl == "" then tbl = {} else tbl = str_to_table(tbl) end
		local add_lines = {}
		for _, xstr in pairs(tbl) do
			local x = str_to_table(xstr)
			add_lines[x.name] = x -- This gets set to last addition, not necessarily latest turn
		end
		for _, x in pairs(add_lines) do
			local turns = tonumber(x.turn) + tonumber(x.length) - turnsthisrun()
			if turns >= 0 then
				if turnsleft == 0 then
					table.insert(lines, string.format([[%s: <b style="color: green">%s</b>]], x.name, turns))
				else
					table.insert(lines, string.format([[%s: <b>%s</b>]], x.name, turns))
				end
			end
		end
	end

	table.insert(lines, "")

	if familiarid() ~= 0 then
		table.insert(lines, string.format([[<center><a href="familiar.php" target="mainpane"><img src="http://images.kingdomofloathing.com/itemimages/%s.gif"></a>%s lbs.<!-- kolproxy charpane familiar text area --></center>]], familiarpicture(), buffedfamiliarweight()))
	else
		table.insert(lines, [[<center><a href="familiar.php" target="mainpane">No familiar</a></center>]])
	end

	local buff_colors = {
		["On the Trail"] = "purple",
		["Everything Looks Red"] = "red",
		["Everything Looks Blue"] = "blue",
		["Everything Looks Yellow"] = "goldenrod",
	}
	local bufflines = {}
	local sorting = {}
	for descid, x in pairs(status().effects) do
		table.insert(sorting, { title = x[1], duration = tonumber(x[2]), imgname = x[3], descid = descid }) -- HACK: tonumber is a workaround for CDM effects being strings or numbers randomly
	end
	table.sort(sorting, function (a, b)
		if a.duration ~= b.duration then return a.duration < b.duration end
		if a.title ~= b.title then return a.title < b.title end
		if a.imgname ~= b.imgname then return a.imgname < b.imgname end
		return a.descid < b.descid
	end)
	local curbuffline = nil
	for _, x in pairs(sorting) do
		local styleinfo = ""
		local imgstyleinfo = ""
		if buff_colors[x.title] then
			styleinfo = string.format([[ style="color: %s"]], buff_colors[x.title])
			imgstyleinfo = string.format([[ style="background-color: %s"]], buff_colors[x.title])
		end
		local str = string.format([[<td title="%s"%s><img src="http://images.kingdomofloathing.com/itemimages/%s.gif" style="width: 25px; height: 25px; cursor: pointer;" onClick='popup_effect("%s");''></td><td title="%s"%s>(%s)</td>]], x.title, imgstyleinfo, x.imgname, x.descid, x.title, styleinfo, x.duration)
		if not curbuffline then
			curbuffline = str
		else
			table.insert(bufflines, string.format([[<tr>%s<td>&nbsp;</td>%s</tr>]], curbuffline, str))
			curbuffline = nil
		end
	end
	if curbuffline then
		table.insert(bufflines, string.format([[<tr>%s<td></td><td></td></tr>]], curbuffline))
	end
	table.insert(lines, [[<center><table>]] .. table.concat(bufflines) .. [[</table></center>]])

	if ascensionstatus() == "Aftercore" then
		local href = "http://kol.obeliks.de" .. raw_make_href("/buffbot/buff", {
			{ key = "style", value = "kol" },
-- 			{ key = "style", value = "kolproxy" },
			{ key = "target", value = playername() },
		})
		table.insert(lines, [[<a href="]]..href..[[" target="mainpane" style="color: green">{Get buffs}</a>]])
	end

	local text = [[
<html>
<head>
	<style type="text/css">
body {
	font-family: Arial, Helvetica, sans-serif;
	background-color: ]] .. bgcolor .. [[;
	color: black;
	font-size: 0.8em;
}
td {
	font-family: Arial, Helvetica, sans-serif;
	font-size: 0.8em;
}
a:link { color: black; }
a:visited {	color: black; }
a:active { color: black; }
.nounder { text-decoration: none; }
.tiny { font-size: 0.9em; }
	</style>
	<script type="text/javascript">
		function popup_effect(descid) {
			var w = window.open("desc_effect.php?whicheffect=" + descid, "effect", "height=200,width=300")
			if (w.focus) w.focus()
		}
	</script>
</head>
<body>
]] .. table.concat(lines, "<br>") .. [[
</body>
</html>]]
	return text, "/kolproxy-quick-charpane"
end)

-- game.php
-- <frameset id=mainset cols="120,*">
-- <frameset id=mainset cols="200,*">

-- TODO: resize frameset, allow custom frame layouts?
